%global srcname twisted

Summary:        Twisted is a networking engine written in Python
Name:           python-%{srcname}
Version:        22.4.0
Release:        5%{?dist}
License:        MIT
URL:            http://twistedmatrix.com/
Source0:        https://github.com/twisted/twisted/archive/%{srcname}-%{version}/%{srcname}-%{version}.tar.gz

Patch0001:      0001-Import-gobject-from-gi.repository-in-Python-3.patch

BuildArch:      noarch

%description
Twisted is a networking engine written in Python, supporting numerous protocols.
It contains a web server, numerous chat clients, chat servers, mail servers
and more.

%package -n python3-%{srcname}
Summary:        Twisted is a networking engine written in Python
BuildRequires:  gcc
BuildRequires:  git-core
BuildRequires:  python3-devel >= 3.3
Recommends:     python3-%{srcname}+tls

%description -n python3-%{srcname}
Twisted is a networking engine written in Python, supporting numerous protocols.
It contains a web server, numerous chat clients, chat servers, mail servers
and more.

%pyproject_extras_subpkg -n python3-%{srcname} tls

%prep
%autosetup -p1 -n %{srcname}-%{srcname}-%{version}
%generate_buildrequires
%pyproject_buildrequires

%build
%pyproject_wheel

%install
%pyproject_install
mkdir -p %{buildroot}%{_mandir}/man1/
for s in conch core mail; do
cp -a docs/$s/man/*.1 %{buildroot}%{_mandir}/man1/
done

mkdir -p %{buildroot}%{python3_sitelib}/twisted/plugins

ln -s ./trial %{buildroot}%{_bindir}/trial-3
ln -s ./twistd %{buildroot}%{_bindir}/twistd-3

%pyproject_save_files %{srcname}
echo "%ghost %{python3_sitelib}/twisted/plugins/dropin.cache" >> %{pyproject_files}

%check
PATH=%{buildroot}%{_bindir}:$PATH PYTHONPATH=%{pyproject_build_lib} %{buildroot}%{_bindir}/trial twisted ||:

%files -n python3-twisted  -f %{pyproject_files}
%license LICENSE
%doc NEWS.rst README.rst
%{_bindir}/cftp
%{_bindir}/ckeygen
%{_bindir}/conch
%{_bindir}/mailmail
%{_bindir}/pyhtmlizer
%{_bindir}/tkconch
%{_bindir}/trial
%{_bindir}/twist
%{_bindir}/twistd
%{_bindir}/trial-3
%{_bindir}/twistd-3
%{_mandir}/man1/cftp.1*
%{_mandir}/man1/ckeygen.1*
%{_mandir}/man1/conch.1*
%{_mandir}/man1/mailmail.1*
%{_mandir}/man1/pyhtmlizer.1*
%{_mandir}/man1/tkconch.1*
%{_mandir}/man1/trial.1*
%{_mandir}/man1/twistd.1*

%changelog
* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.4.0-5
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.4.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.4.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.4.0-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Dec 20 2022 Miaojun Dong <zoedong@tencent.com> - 22.4.0-1
- initial build
